//
//  ViewController.swift
//  Breakpoints
//
//  Created by Bart Jacobs on 21/03/2018.
//  Copyright © 2018 Cocoacasts. All rights reserved.
//

import UIKit

struct User {
    
    let first: String
    let last: String
    
}

class ViewController: UIViewController {

    enum JSONError: Error {
        
        case resourceNotFound
        case unableToLoadData
        case invalidJSON
        
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // Initialize User
        let currentUser = User(first: "Bart", last: "Jacobs")
        
        // Store User in User Defaults
        UserDefaults.standard.set(currentUser, forKey: "currentUser")
        
        /*
        do {
            // Load JSON Data
            let json = try loadJSONData()
            
            print(json)
        } catch {
            print(error)
        }
        */
    }
    
    private func loadJSONData() throws -> Any {
        let data = try loadData()
        
        guard let json = try? JSONSerialization.jsonObject(with: data, options: []) else {
            throw JSONError.invalidJSON
        }
        
        return json
    }
    
    private func loadData() throws -> Data {
        guard let url = Bundle.main.url(forResource: "data", withExtension: "json") else {
            throw JSONError.resourceNotFound
        }
        
        guard let data = try? Data(contentsOf: url) else {
            throw JSONError.unableToLoadData
        }
        
        return data
    }
    
}
